<?php

/* extraction taille totale d'un dossier, 
   et calcul du nombre de fichiers et de 
   dossiers contenus */
function getSize($data) {
  global $nfile, $ndir;
  $size = 0;
  /* ouverture */
  if($dir = opendir($data)) {
    /* listage */
    while($entry = readdir($dir)) {
	  /* protection contre boucle infini */
	  if(!in_array($entry, array(".",".."))) {
	    /* cas dossier, récursion */
        if(is_dir($data."/".$entry)) {
	      $size += getSize($data."/".$entry);
		  $ndir++;
		/* cas fichier */
	    } else {
	      $size += filesize($data."/".$entry);
		  $nfile++;
	    }
	  }
	}
	/* fermeture */
	closedir($dir);
  }
  return $size;
}


/* formatage de la taille */
function formatSize($s) {
  /* unités */
  $u = array('octets','Ko','Mo','Go','To');
  /* compteur de passages dans la boucle */
  $i = 0;
  /* nombre à afficher */
  $m = 0;
  /* division par 1024 */
  while($s >= 1) {
    $m = $s;
	$s /= 1024;
	$i++;
  }
  if(!$i) $i=1;
  $d = explode(".",$m);
  /* s'il y a des décimales */
  if($d[0] != $m) {
    $m = number_format($m, 2, ",", " ");
  }
  return $m." ".$u[$i-1];
}

/* formatage du type */
function assocType($type) {
  /* tableau de conversion */
  $t = array(
    'fifo' => "file",
    'char' => "fichier spécial en mode caractère",
    'dir' => "dossier",
    'block' => "fichier spécial en mode bloc",
    'link' => "lien symbolique",
    'file' => "fichier",
    'unknown' => "inconnu"
  );
  return $t[$type];
}

/* description de l'extention */
/* EN MINUSCULE */
function assocExt($ext) {
  $e = array(
	'' => "inconnu",
	'doc' => "Microsoft Word",
	'xls' => "Microsoft Excel",
	'xlsx' => "Microsoft Excel",
	'ppt' => "Microsoft Power Point",
	'pdf' => "Adobe Acrobat",
	'zip' => "Archive WinZip",
	'txt' => "Document texte",
	'gif' => "Image GIF",
	'tif' => "Image TIF",
	'bmp' => "Image BMP",
	'jpg' => "Image JPEG",
	'jpeg' => "Image JPEG",
	'avi' => "Vidéo AVI",
	'wmv' => "Vidéo WMV",
	'nov' => "Vidéo NOV",
	'MP4' => "Vidéo MP4",
	'pps' => "Diapo PPS",
	'png' => "Image PNG",
	'php' => "Script PHP",
	'php3' => "Script PHP",
	'htm' => "Page web",
	'html' => "Page web",
	'css' => "Feuille de style",
	'js' => "JavaScript",
	'ini' => "Fichier systeme",
	'db' => "Fichier systeme",
	'bat' => "Fichier systeme",
	'dll' => "Dynamic Link Library",
	'exe' => "Fichier executable"
  );
  if(in_array(strtolower($ext), array_keys($e))) {
    return $e[strtolower($ext)];
  } else {
    return $e[''];
  }
}


/* format de type de fichier */
function mfunGetPerms( $in_Perms ) { 
   $sP;

   if($in_Perms & 0x1000)     // FIFO pipe
     $sP = 'p'; 
   elseif($in_Perms & 0x2000) // Character special
     $sP = 'c'; 
   elseif($in_Perms & 0x4000) // Directory
     $sP = 'd'; 
   elseif($in_Perms & 0x6000) // Block special
     $sP = 'b';
   elseif($in_Perms & 0x8000) // Regular
     $sP = '&minus;';
   elseif($in_Perms & 0xA000) // Symbolic Link
     $sP = 'l';
   elseif($in_Perms & 0xC000) // Socket
     $sP = 's';
   else                       // UNKNOWN
     $sP = 'u'; 

   // owner
   $sP .= (($in_Perms & 0x0100) ? 'r' : '&minus;') .
          (($in_Perms & 0x0080) ? 'w' : '&minus;') . 
          (($in_Perms & 0x0040) ? (($in_Perms & 0x0800) ? 's' : 'x' ) : 
                                  (($in_Perms & 0x0800) ? 'S' : '&minus;')); 

   // group
   $sP .= (($in_Perms & 0x0020) ? 'r' : '&minus;') .
          (($in_Perms & 0x0010) ? 'w' : '&minus;') . 
          (($in_Perms & 0x0008) ? (($in_Perms & 0x0400) ? 's' : 'x' ) : 
                                  (($in_Perms & 0x0400) ? 'S' : '&minus;')); 

   // world
   $sP .= (($in_Perms & 0x0004) ? 'r' : '&minus;') .
          (($in_Perms & 0x0002) ? 'w' : '&minus;') . 
          (($in_Perms & 0x0001) ? (($in_Perms & 0x0200) ? 't' : 'x' ) : 
                                  (($in_Perms & 0x0200) ? 'T' : '&minus;')); 
   return $sP;
 }


/* infos à extraire */
function infofichier($chemin,$data) {
  $tableau['name'] = $chemin;
  $tableau['size'] = filesize($data."/".$chemin);
  $tableau['date'] = filemtime($data."/".$chemin);
  $tableau['type'] = filetype($data."/".$chemin);
  $tableau['access'] = fileatime($data."/".$chemin);
  $tableau['perms'] = mfunGetPerms(fileperms($data."/".$chemin));
  $t = explode(".", $chemin);
  $tableau['ext'] = $t[count($t)-1];
  return $tableau;
}
function inforep($chemin,$data) {
  $tableau['name'] = $chemin;
  $tableau['size'] = getSize($data."/".$chemin);
  //$tableau['size'] = filesize($data."/".$chemin);
  //$t = explode(".", $chemin);
  //$tableau['ext'] = $t[count($t)-1];
  return $tableau;
}






function explorer_fichier($repertoire) 
{
global $data, $hauteur; $iphone; $large; //appel des variables qui sont hors de la fonction
$nrv = 0;
$nrp = 0;

// on remplace les caracteres posants problemes
	$a_remplacer = array("..", "/.", "\"", "./", "//");
	$repertoire = str_replace($a_remplacer, "", $repertoire);
//  transformation des accents et remise en place des "/"
	$dossier = str_replace("%2F", "/", rawurlencode($repertoire."/"));
if ($dir = opendir($repertoire)) 
	{
	// tableaux
	$rep = array();
	$fichier = array();
	while($var = readdir($dir))
		{
		if(is_dir($repertoire."/".$var)) 
			{
			if(!in_array($var, array(".",".."))) 
				{
				$rep[] = inforep($var,$repertoire);
				}
  			}
		else 
			{
			$fichier[] = infofichier($var,$repertoire);
			}
		}
	}
	sort($rep);
	sort($fichier);
	foreach($rep as $affichage)
		{
		echo '<tr>';
		echo '<td><a href='.$_SERVER['PHP_SELF'].'?dir='.rawurlencode(str_replace($data.'/', "", $repertoire.'/'.$affichage['name'])).'><img src="images/dir-close.gif" border=0 />'.$affichage['name'].'</a>   <a href="properties.php?type=dir&dir='.rawurlencode(str_replace($data.'/', "", $repertoire.'/'.$affichage['name'])).'" title="Télécharger" onclick="window.open(this.href,\'\',\'menubar=no,toolbar=no,location=no,status=no,scrollbars=no,resizable=yes,width=430,height=330\'); return false;"><img src="images/cle-usb.png" height="20" width="20" /></a></td>';
		echo '<td>'.formatSize($affichage['size']).'</td>';
		echo '<td></td>';
		echo '<td></td>';
		echo '<td></td>';
		echo '<td></td>';
		echo '<td></td>';
		echo '</tr>';
		}
	foreach($fichier as $affichage)
		{
		$nbrp = $nrp+1;
		$nbrv = $nrv+1;
		echo '<tr>';
		echo '<td><a href="properties.php?type=file&dir='.rawurlencode(str_replace($data.'/', "", $repertoire.'/'.$affichage['name'])).'" title="Télécharger" onclick="window.open(this.href,\'\',\'menubar=no,toolbar=no,location=no,status=no,scrollbars=no,resizable=yes,width=430,height=330\'); return false;"><img src="images/file-none.gif" border=0 />'.$affichage['name'].'</a>';
		echo '<td>'.formatSize($affichage['size']).'</td>';
		echo '<td>'.date("d/m/Y", $affichage['date']).'</td>';
		echo '<td>'.assocType($affichage['type']).'</td>';
		echo '<td>'.assocExt($affichage['ext']).'</td>';
		echo '<td>'.date("d/m/Y", $affichage['access']).'</td>';
		//echo '<td>'.$affichage['perms'].'</td>';
		echo '<td>';

		if((assocExt($affichage['ext']) == "Image JPEG")|(assocExt($affichage['ext']) == "Image BMP")|(assocExt($affichage['ext']) == "Image PNG")) {
			echo "N°:".$nbrp.": <a href=\"javascript:void(0);\" onClick=\"window.open('diapo.php?dir=".rawurlencode(str_replace($data.'/', "",$repertoire))."&nr=".$nrp."&haut='+(Math.round(screen.height))+'&large='+(Math.round(screen.width))+'&auto=Non','Proprietes','top=0,left=0,width='+screen.width+',height='+screen.height+',menubar=no,resize=no,location=yes,status=no,scrollbars=no,')\">".$affichage['name']."</a>";
			echo '</td>';
			$nrp = $nrp+1;
			}
		elseif ((assocExt($affichage['ext']) == "Vidéo AVI")or(assocExt($affichage['ext']) == "Vidéo WMV")) {
			echo "N°:".$nbrv.": <a href=\"javascript:void(0);\" onClick=\"window.open('video.php?dir=".rawurlencode(str_replace($data.'/', "",$repertoire))."&name=".rawurlencode($affichage['name'])."&nr=".$nrv."&haut='+(screen.height*0.85)+'&large='+(screen.width)+'','Proprietes','fullscreen=yes,menubar=yse,toolbar=yes,location=yes,status=no,scrollbars=no,resizable=yes')\">".$affichage['name']."</a>";
			echo '</td>';
			$nrv = $nrv+1;
			}
		else {
			echo '<a href='.$dossier.rawurlencode($affichage['name']).' target="_blank">   Télécharger</a></td>';
			}
		echo '</tr>';
		}
	//closedir($repertoire);
	
}

function explorer_rep($repertoire, $chemin, $marge=1)
{
	global $data; //appel des variables qui sont hors de la fonction
	$rep = array();
	$le_repertoire = opendir($repertoire) or die("Erreur le repertoire $repertoire existe pas");
	while($var = @readdir($le_repertoire))
	{
	if ($var == "." || $var == "..") continue;
	if(is_dir($repertoire.'/'.$var)) // si c'est un repertoire
		{
		$rep[] = $var;
		}
	}
	sort($rep);
	foreach($rep as $affichage)
	{
	// on remplace les caracteres posants problemes
	$a_remplacer = array("  ", " ", "'", "é", "è", "à", "ç", "//", "/", "(", ")");
	$affichage_simple = str_replace($a_remplacer, "_", $affichage);
	$chemin_simple = str_replace($a_remplacer, "_", $chemin);
	$repertoire_simple = str_replace($a_remplacer, "_", $repertoire);
	$affichage1 = str_replace("(", "\(", $affichage);
	$affichage2 = str_replace(")", "\)", $affichage);
	
	// on affiche les repertoires qui contiennent uniquement ceux demandés. 
	if(preg_match('/'.$repertoire_simple.'/', $chemin_simple))
		{
		// marge sur les repertoires
		for($i=1; $i<=(6*$marge); $i++) {
		echo "&nbsp;";
		}
		// Le repertoire est celui demandé
		if($chemin == $repertoire.'/'.$affichage)
			{
			echo '<b id="selection" style="FONT-WEIGHT: bold"><img src="images/dir-open.gif" />'.$affichage.'</b><br/>';
			} 
		// on met une icone special pour le repertoire qui fait parti du chemin
		elseif(preg_match('/'.$affichage_simple.'/', $chemin_simple))
			{
			echo '<a id="selection" style="FONT-WEIGHT: bold" href='.$_SERVER['PHP_SELF'].'?dir='.rawurlencode(str_replace($data.'/', "", $repertoire.'/'.$affichage)).'><img src="images/dir-open.gif" border=0 />'.$affichage.'</a><br/>';
			}
			else
			{
			echo '<a href='.$_SERVER['PHP_SELF'].'?dir='.rawurlencode(str_replace($data.'/', "", $repertoire.'/'.$affichage)).'><img src="images/dir-close.gif" border=0 />'.$affichage.'</a><br/>';
			}
		echo 
		explorer_rep($repertoire.'/'.$affichage, $chemin, $marge+1); // fonction recursif pour explorer le nouveau repertoire
		}
		
        }
    
    closedir($le_repertoire);
}

function chercher_rep($repertoire, $chercher)
{
global $data; //appel des variables qui sont hors de la fonction
	$rep = array();
	$le_repertoire = opendir($repertoire) or die("Erreur le repertoire $data existe pas");
	while($var = @readdir($le_repertoire))
	{
	if ($var == "." || $var == "..") continue;
	if(is_dir($repertoire.'/'.$var)) // si c'est un repertoire
		{
		$rep[] = $var;
		}
	}
	sort($rep);
	foreach($rep as $affichage)
	{
	//echo $chercher.' et '.sans_accents($affichage);
	// on affiche les repertoires qui contiennent uniquement ceux demandés. 
	if(preg_match('/'.$chercher.'/', sans_accents($affichage)))
			{
			echo '<a href='.$_SERVER['PHP_SELF'].'?dir='.rawurlencode(str_replace($data.'/', "", $repertoire.'/'.$affichage)).'><img src="images/dir-close.gif" border=0 />'.$affichage.'</a><br/>';
			}
		chercher_rep($repertoire.'/'.$affichage, $chercher); // fonction recursif pour explorer le nouveau repertoire
		}
    closedir($le_repertoire);
}

function chercher_fichier($repertoire, $chercher)
{
	global $data;// $hauteur, $iphone, $large; //appel des variables qui sont hors de la fonction
$nrv = 0;
$nrp = 0;
// on remplace les caracteres posants problemes
	$a_remplacer = array("..", "/.", "\"", "./", "//");
	$repertoire = str_replace($a_remplacer, "", $repertoire);
//  transformation des accents et remise en place des "/"
	$dossier = str_replace("%2F", "/", rawurlencode($repertoire."/"));
	if ($dir = opendir($repertoire))
    {
		$fichier = array();
		$rep = array();
		while($var = readdir($dir))
		{
			if(is_dir($repertoire."/".$var))
            {
				if(!in_array($var, array(".","..")))
                {
					$rep[] = inforep($var,$repertoire);
                }
            }
        //else
			elseif(preg_match('/'.$chercher.'/', sans_accents($var)))
            {
       // echo '<br />'.sans_accents($var).' et '.sans_accents($chercher);
				$fichier[] = infofichier($var,$repertoire);
            }
        }
    }
	sort($fichier);
	//sort($rep);
	foreach($fichier as $affichage)
    {
		$nbrp = $nrp+1;
		$nbrv = $nrv+1;
		echo '<tr>';
		echo '<td><a href="properties.php?type=file&dir='.rawurlencode(str_replace($data.'/', "", $repertoire.'/'.$affichage['name'])).'" title="Télécharger" onclick="window.open(this.href,\'\',\'menubar=no,toolbar=no,location=no,status=no,scrollbars=no,resizable=yes,width=430,height=330\'); return false;"><img src="images/file-none.gif" border=0 />'.$affichage['name'].'</a>';
		echo '<td>'.formatSize($affichage['size']).'</td>';
		echo '<td>'.date("d/m/Y", $affichage['date']).'</td>';
		echo '<td>'.assocType($affichage['type']).'</td>';
		echo '<td>'.assocExt($affichage['ext']).'</td>';
		echo '<td>'.date("d/m/Y", $affichage['access']).'</td>';
		echo '<td>';
		if((assocExt($affichage['ext']) == "Image JPEG")|(assocExt($affichage['ext']) == "Image BMP")|(assocExt($affichage['ext']) == "Image PNG"))
		{
			echo "<a href=\"javascript:void(0);\" onClick=\"window.open('diapo.php?dir=".rawurlencode(str_replace($data.'/', "",$repertoire))."&img=".rawurlencode($affichage['name'])."&haut='+(Math.round(screen.height))+'&large='+(Math.round(screen.width))+'&auto=Non','Proprietes','top=0,left=0,width='+screen.width+',height='+screen.height+',menubar=no,resize=no,location=yes,status=no,scrollbars=no,')\">".$affichage['name']."</a>";
			$nrp = $nrp+1;
        }
		elseif ((assocExt($affichage['ext']) == "Vidéo AVI")or(assocExt($affichage['ext']) == "Vidéo WMV"))
		{
			echo "<a href=\"javascript:void(0);\" onClick=\"window.open('video.php?dir=".rawurlencode(str_replace($data.'/', "",$repertoire))."&name=".rawurlencode($affichage['name'])."&nr=".$nrv."&haut='+(screen.height*0.85)+'&large='+(screen.width)+'','Proprietes','fullscreen=yes,menubar=yse,toolbar=yes,location=yes,status=no,scrollbars=no,resizable=yes')\">".$affichage['name']."</a>";
			$nrv = $nrv+1;
        }
		else
        {
			echo '<a href='.$dossier.rawurlencode($affichage['name']).' target="_blank">   Télécharger</a></td>';
        }
		echo '</td>';
		echo '</tr>';
    }
	foreach($rep as $affichage)
    {
		//echo $affichage;
		chercher_fichier($repertoire.'/'.$affichage['name'], $chercher); // fonction recursif pour explorer le nouveau repertoire
		// echo $affichage['name'];
		//echo '<br />'.$repertoire.'/'.$affichage['name'];
    }
}








function sans_accents( $str, $charset='utf-8' ) {
 
    $str = htmlentities( $str, ENT_NOQUOTES, $charset );
    
    $str = preg_replace( '#&([A-za-z])(?:acute|cedil|caron|circ|grave|tilde|uml);#', '\1', $str );// É,Ç,Č,Ê,È,Ã,Ë
	$str = trim($str); // supprime le premier et le dernier caracterre si c'est un espace, tabulation, ou retour chario
    return strtoupper($str); // retour en majuscule
}

function open_fenetre()
                        {
                                window.open('pageb.html','nom_de_ma_popup','menubar=no, scrollbars=no, top=100, left=100, width=300, height=200');
                        }

?>